#!/usr/bin/python3 
#from my_network import Architecture
import my_network as nn
import leg_dynamics as ld
import knowledge_transfer as kt
import tensorflow as tf
import numpy as np
import roslib
roslib.load_manifest('spider_control')
from matplotlib import pyplot
#import pyplot as plt
from geometry_msgs import *
import rospy, yaml, sys
#from osrf_msgs.msg import JointCommands
from sensor_msgs.msg import JointState
#from joint_states_listener.srv import *
#from joint_States_listener.srv import ReturnJointStates
import threading
import time
from std_msgs.msg import Float64
from std_msgs.msg import Header
from sklearn.multiclass import OneVsRestClassifier
from sklearn.svm import LinearSVC
import csv
import os.path
import json
import _pickle as pickle




g_joint_states = None
g_positions = None
g_pos1 = None
#tactile_output = None



def tactile_callback(msg):
    global tactile_output
    tactile_output = msg.data
    leg.update_tactile(tactile_output)

def joint_callback(data, args):
    global g_positions
    global g_joint_states
    global g_pos1
    global new_position
    global knowledge_dict
    global main_dict
    main_dict = {}
    knowledge_dict = {}
    simulation_mode = args[0] #to distinguish between training and testing
    model_number = args[1]#to distiguish between the type of model to train incase of training
    rospy.loginfo(data.position)#testing
    pub_msg = JointState() # Make a new msg to publish results
    pub_msg.header = Header()
    pub_msg.name = data.name
    pub_msg.velocity = [10] * len(data.name)
    pub_msg.effort = [100] * len(data.name)
    g_positions = data.position
    velocity = 10*len(data.name)
    effort = 10*len(data.name)
    carollis_inp = leg.carollis_input()
    print("carollis input is ")#testing
    print(carollis_inp)
    knowledge_out, out_tensor, knowledge_dict = knowledge.run(carollis_inp)
    model_num = np.where(knowledge_out == np.amax(knowledge_out))
    reward = leg.leg_run()
    if(simulation_mode == 'test'):
        if(model_num == 0 ):
            new_position, main_dict = model1.nn_run(g_positions)
            print("printing new position")
            print(new_position)#debuggings
            pub_msg.position = new_position
        elif(model_num == 1):
            print("printing new position")
            new_position, main_dict = model2.nn_run(g_positions)
            print(new_position)#debugging
            pub_msg.position = new_position
        elif(model_num == 2):
            print("printing new position")
            new_position, main_dict = model3.nn_run(g_positions)
            print(new_position)#degingbug
            pub_msg.position = new_position
        elif(model_num == 3):
            new_position, main_dict = model4.nn_run(g_positions)
            print("printing new position")
            print(new_position)#debugging
            pub_msg.position = new_position
        leg.update_angles(new_position)
        leg.update_effort(effort)
        leg.update_velocity(velocity)
        joint_pub.publish(pub_msg)
    elif(simulation_mode == 'train'):
        ou = tf.one_hot([model_number-1], 4)
        knowledge.learn(out_tensor, ou)
        if(model_number == 1):
            print("printing new position")
            new_position, main_dict = model1.nn_run(g_positions)
            print(new_position)#debugging
            pub_msg.position = new_position
        elif(model_number == 2):
            print("printing new position")
            new_position, main_dict = model2.nn_run(g_positions)
            print(new_position)#debugging
            pub_msg.position = new_position
        elif(model_number == 3):
            print("printing new position")
            new_position, main_dict = model3.nn_run(g_positions)
            print(new_position)#debugging
            pub_msg.position = new_position
        elif(model_number == 4):
            print("printing new position")
            new_position, main_dict = model4.nn_run(g_positions)
            print(new_position)#debugging
            pub_msg.position = new_position
        leg.update_angles(new_position)
        leg.update_effort(effort)
        leg.update_velocity(velocity)
        joint_pub.publish(pub_msg)

if __name__=='__main__':
    global variables_list_main
    global variables_list_kt
    global variables_list_m
    graph1 = tf.Graph()
    with graph1.as_default():
        model1 = nn.Architecture(4, 24, 1)
    graph2 = tf.Graph()
    with graph2.as_default():
        model2 = nn.Architecture(4, 24, 2)
    graph3 = tf.Graph()
    with graph3.as_default():
        model3 = nn.Architecture(4, 24, 3)
    graph4 = tf.Graph()
    with graph4.as_default():
        model4 = nn.Architecture(4, 24, 4)
    graph5 = tf.Graph()
    with graph5.as_default():
        knowledge = kt.MultiClassLogistic(8, 3)
    #if(os.path.isfile('main_network.csv') == True):
    #    try:
    #        f2.open('main_network.csv')
    #    except IOError:
    #        print('file is not accessible')

    pos = np.random.uniform(low = 0, high =2.5, size=24)
    vel = 10
    eff = 100
    tact = np.zeros(8)
    leg = ld.Leg_attribute(pos, vel, eff, tact)
    mode = input('please enter whether you want to test or train ?')
    if(mode == 'train'):
        model_number = int(input('please enter the model you wish to train i.e. 1, 2, 3, 4 \n '))
        rospy.init_node('joint_logger_node', anonymous = True)
        rospy.Subscriber("/sr_tactile/touch/ff", Float64, tactile_callback)
        rospy.Subscriber("joint_states", JointState, joint_callback, (mode, model_number))
        joint_pub = rospy.Publisher('target_joint_states', JointState, queue_size = 10)
        rospy.spin()
        print("writing csv file")
        for key in knowledge_dict.keys():
            print("%s,%s\n"%(key,knowledge_dict[key]))
        w = csv.writer(open("weights.csv", "w"))
        for key, val in knowledge_dict.items():
            w.writerow([key, val])
    else:
        rospy.init_node('jint_logger_node', anonymous=True)
        rospy.Subscriber("/sr_tactile/touch/ff", Float64, tactile_callback)
        rospy.Subscriber("joint_states", JointState, joint_callback, (mode))
        joint_pub = rospy.Publisher('target_joint_states', JointState, queue_size = 10)
        rospy.spin()

    

