#!/usr/bin/python3 
import tensorflow as tf
import numpy as np
from matplotlib import pyplot
#import pyplot as plt
import math
import time
from sklearn.preprocessing import normalize

class MultiClassLogistic:

    def __init__(self, neurons, layers):
        self.neurons = neurons
        self.layers =  layers
        self.weight_initer = tf.compat.v1.truncated_normal_initializer(mean=0.0, stddev=0.01)
        self.weight_initer1 = tf.compat.v1.truncated_normal_initializer(mean=1.0, stddev=0.01)
        self.weight_initer2 = tf.compat.v1.truncated_normal_initializer(mean=2.0, stddev=0.01)
        self.bias_initer =tf.compat.v1.truncated_normal_initializer(mean=0.1, stddev=0.01)
        self.bias_initer1 =tf.compat.v1.truncated_normal_initializer(mean=0.2, stddev=0.01)
        self.bias_initer2 =tf.compat.v1.truncated_normal_initializer(mean=0.3, stddev=0.01)
        
        
    #defining input function that can accept the output from previous layer and can calculate the input for present layer

    def input_function(self, a = [], b = [], c = []):
        'where b=output value of neurons from previous layer, a = weights of neurons from the present layer, c = bias'
        multiplication = tf.multiply(a, b)
        add  = tf.add(multiplication, c)
        sess = tf.Session()
        n_input = sess.run(add)
        return n_input
    #function that returns the softmax of the output layer or any given array of neurons
    def out_softmax(self, neuron_out):
        output = tf.nn.softmax(neuron_out)
        with tf.Session() as sess:
            out = sess.run(output)
        return out

    def kt_learning(self, learning_rate, n_out , n_preferred):
        'where n_out is the actual output and n_preffered is the prefered output of the network'
        loss = tf.reduce_mean(tf.nn.softmax_cross_entropy_with_logits(labels=n_out, logits=n_preferred))
        optimizer = tf.train.GradientDescentOptimizer(learning_rate).minimize(loss)
        init_l = tf.compat.v1.global_variables_initializer()
        with tf.Session() as sess:
            sess.run(init_l)
            sess.run(optimizer)
    def normalization(self, inputs):
        a_min = min(inputs)
        a_max = max(inputs)
        for i in range(len(inputs)):
            inputs[i] = (inputs[i]-a_min)/(a_max-a_min)
    
    def get_var_list(self):
        ls = tf.trainable_variables()
        ii = tf.global_variables_initializer()
        with tf.Session() as sessio:
            sessio.run(ii)
            l = sessio.run(ls)
        return l, ls
    
    
    def run(self, carollis_input):
        k_dict = {}
        c_in=normalize(carollis_input, axis = 0)
        print('normalized carollis input is \n')
        print(c_in)
        c_in = np.array(c_in)
        c_input = tf.compat.v1.convert_to_tensor(c_in, tf.float64)
        sess = tf.InteractiveSession()
        #'finding the output of the input layer'
        with tf.compat.v1.variable_scope("weight_in", reuse=tf.compat.v1.AUTO_REUSE):
            weight_i = tf.compat.v1.get_variable("weight_input", dtype=tf.float64, shape=[self.neurons, 1], initializer=self.weight_initer)
            init_i = tf.compat.v1.global_variables_initializer()
            sess.run(init_i)
        with tf.compat.v1.variable_scope("weight_hid", reuse=tf.compat.v1.AUTO_REUSE):   
            weight_h = tf.compat.v1.get_variable("weight_hidden", dtype=tf.float64, shape=[self.neurons, 1], initializer=self.weight_initer1)
            init_h = tf.compat.v1.global_variables_initializer()
            sess.run(init_h)
        with tf.compat.v1.variable_scope("weight_out", reuse=tf.compat.v1.AUTO_REUSE): 
            weight_o = tf.compat.v1.get_variable("weight_input", dtype=tf.float64, shape=[4, 2], initializer=self.weight_initer2)
            init_o = tf.compat.v1.global_variables_initializer()
            sess.run(init_o)
        with tf.compat.v1.variable_scope("bias_in", reuse=tf.compat.v1.AUTO_REUSE): 
            bias_i = tf.compat.v1.get_variable("bias_input", dtype=tf.float64, shape=[self.neurons, 1], initializer=self.bias_initer)
            init_i_b = tf.compat.v1.global_variables_initializer()
            sess.run(init_i_b)    
        with tf.compat.v1.variable_scope("bias_hid", reuse=tf.compat.v1.AUTO_REUSE): 
            bias_h = tf.compat.v1.get_variable("bias_hidden", dtype=tf.float64, shape=[self.neurons, 1], initializer=self.bias_initer1)
            init_h_b = tf.compat.v1.global_variables_initializer()
            sess.run(init_h_b)
        with tf.compat.v1.variable_scope("bias_out", reuse=tf.compat.v1.AUTO_REUSE): 
            bias_o = tf.compat.v1.get_variable("bias_out", dtype=tf.float64, shape=[1, 4], initializer=self.bias_initer2)
            init_o_b = tf.compat.v1.global_variables_initializer()
            sess.run(init_o_b)
        uninitialized_variables = []
        #print("printing the names of all variables")
        #print(tf.all_variables())
        for var in tf.all_variables():
            try:
                sess.run(var)
            except tf.errors.FailedPreconditionError:
                uninitialized_variables.append(var)
        
        init = tf.variables_initializer(uninitialized_variables)
        sess.run(init)
        #print("priniting uninitialized variables")
        #print(sess.run(tf.report_uninitialized_variables(uninitialized_variables)))
        knowledge_input = tf.compat.v1.add(tf.compat.v1.multiply(c_input, weight_i), bias_i)
        #sess.run(knowledge_input)
        knowledge_hidden = tf.compat.v1.nn.leaky_relu(knowledge_input, alpha=0.01) 
        #'calculating the output of hidden layer'
        knowledge_hidden_output = 3.14*(tf.compat.v1.add(tf.compat.v1.multiply(knowledge_hidden, weight_h), bias_h))#input function of hidden layer
        knowledge_hidden_out = tf.compat.v1.nn.leaky_relu(knowledge_hidden_output, alpha=0.01, name='leaky_relu')
          
        #sess.run(knowledge_hidden_out)
        #'calculating the input of output layer'
        knowledge_hidden_out = tf.compat.v1.reshape(knowledge_hidden_out, [4, 2])#for quadrant method
        out_mult = tf.compat.v1.multiply(knowledge_hidden_out, weight_o)
        out_add = tf.compat.v1.add(out_mult[:, 0], out_mult[:, 1])
        in_out = tf.compat.v1.add(out_add, bias_o)
        #deb = sess.run(in_out)
        #print("printing the shape of tensor in last layer")
        #print(tf.shape(in_out))
        #print(deb)
        in_out = tf.compat.v1.reshape(in_out, [1, 4])
        #i_o = sess.run(in_out)
        #r_i_o = np.reshape(i_o, (8, 1))
        #outt = np.add(r_i_o[0:4, 0], r_i_o[4:8, 0])
        #outt = np.reshape(outt, (4, 1))
        #out_multt = tf.placeholder(tf.float64, shape=(4, 1))
        #in_outt = tf.add(out_multt, bias_o)
        output = sess.run(in_out)
        variables_list_kt =  tf.trainable_variables()
        variables_kt = sess.run(variables_list_kt)
        variables_list_kt, variables_kt = self.get_var_list()
        for var, val in zip(variables_kt, variables_list_kt):
            #print("var: {}, value: {}".format(var.name, val))
            k_dict[var.name] = val
        #output = sess.run(in_out)
        #'finding the softmax output of the neurons'
        #just testing
        #softmax_output = tf.nn.softmax(in_out)
        #output = sess.run(softmax_output)
        sess.close()
        return output, in_out, k_dict
    def learn(self, preferred_out, soft_out):
        self.kt_learning(0.1, soft_out, preferred_out)
    
def one_hot_encoding(model_type):
    a_1 = np.zeros((3))
    if (model_type == 1):
        hot_encoded_matrix = np.insert(a_1, 0, 1, axis=None)#insert 1 in the first coloumn in x axis
    elif(model_type == 2):
        hot_encoded_matrix = np.insert(a_1, 1, 1, axis=None)
    elif(model_type == 3):
        hot_encoded_matrix = np.insert(a_1, 2, 1, axis=None)
    elif(model_type == 4):
        hot_encoded_matrix = np.insert(a_1, 3, 1, axis=None)
    else:
        raise ValueError(f"Value {model_type} is not a valid model number")
    return hot_encoded_matrix