#!/usr/bin/python3 
import tensorflow as tf
import random
import numpy as np
from matplotlib import pylab
import pylab as plt
import math
import time
import leg_dynamics as ld


    
class  Architecture:
    'Common class defining the architecture of the neural network i.e. number of neurons in each layer and number of layers'

    def __init__(self, layers, neurons, number):
        self.layers = layers
        self.neurons = neurons
        self.number = number#number of the model
        #self.neurons_hidden_context = tf.compat.v1.placeholder(dtype = tf.float64, shape=[8, 1], name="hidden_context")
        #self.is_filled = tf.compat.v1.placeholder(tf.bool)
        self.neuron_hidden_context = None
        self.weight_initer = tf.truncated_normal_initializer(mean=1.0, stddev=0.01)
        self.weight_initer1 = tf.truncated_normal_initializer(mean=1.0, stddev=0.05)
        self.weight_initer2 = tf.truncated_normal_initializer(mean=1.0, stddev=0.1)
        self.weight_initer3 = tf.truncated_normal_initializer(mean=1.0, stddev=0.15)
        self.bias_initer =tf.truncated_normal_initializer(mean=0.1, stddev=0.01)
        self.bias_initer1 =tf.truncated_normal_initializer(mean=0.1, stddev=0.01)
        self.bias_initer2 =tf.truncated_normal_initializer(mean=0.1, stddev=0.01)
        self.bias_initer3 =tf.truncated_normal_initializer(mean=0.1, stddev=0.01)
     # get neuron value method helps us to write the joint angles to the individual neurons which we can later use for learning
    def reward_method(self, j_angles):
        mask = tf.compat.v1.constant([0.12, 0.33, 0.5])
        mask = tf.compat.v1.tile(mask, [2])
        mask_1 = tf.compat.v1.constant([0.12, 0.33, 0.5])
        mask_1 = tf.compat.v1.tile(mask_1, [8])
        mask_1 = tf.compat.v1.reshape(mask_1, shape=[8, 3])
        j_angles_0 = tf.compat.v1.reshape(j_angles, shape=[4, 6])
        j_angles_1 = tf.compat.v1.reshape(j_angles, shape=[8, 3])
        com_1 = tf.compat.v1.multiply(mask, j_angles_0[0, :])
        com_2 = tf.compat.v1.multiply(mask, j_angles_0[1, :])
        com_3 = tf.compat.v1.multiply(mask, j_angles_0[2, :])
        com_4 = tf.compat.v1.multiply(mask, j_angles_0[3, :])
        x_com_1 = tf.compat.v1.math.cos(com_1)
        x_com_2 = tf.compat.v1.math.cos(com_2)
        x_com_3 = tf.compat.v1.math.cos(com_3)
        x_com_4 = tf.compat.v1.math.cos(com_4)
        y_com_1 = tf.compat.v1.math.sin(com_1)
        y_com_2 = tf.compat.v1.math.sin(com_2)
        y_com_3 = tf.compat.v1.math.sin(com_3)
        y_com_4 = tf.compat.v1.math.sin(com_4)
        x_com = tf.add(tf.add(tf.add(x_com_1, x_com_2), x_com_3), x_com_4)
        y_com = tf.add(tf.add(tf.add(y_com_1, y_com_2), y_com_3), y_com_4)
        m_com = tf.compat.v1.multiply(mask_1, j_angles_1)
        m_com_x = tf.compat.v1.math.cos(m_com)
        m_com_x = tf.compat.v1.math.reduce_sum(m_com_x)
        m_com_y = tf.compat.v1.math.sin(m_com)
        m_com_y = tf.compat.v1.math.reduce_sum(m_com_y)
        x_mid = 0.5*(tf.add(x_com[0:2], x_com[3:5]))
        y_mid = 0.5*(tf.add(y_com[0:2], y_com[3:5]))
        x_mid = tf.compat.v1.math.reduce_sum(x_mid)
        y_mid = tf.compat.v1.math.reduce_sum(y_mid)
        m = 0.017*(tf.compat.v1.math.divide(tf.compat.v1.math.subtract(m_com_y, y_mid),tf.compat.v1.math.subtract(m_com_x, x_mid)))
        return m
    def NN_learningPunishment(self, LearningRate, punishment):
        #a method to minimize the rewards and alot the weights based on that
        optimizer = tf.train.GradientDescentOptimizer(LearningRate).minimize(punishment)
        with tf.Session as sess:
            sess.run(optimizer)
        return
    def NN_learningReward(self, LearningRate, reward):
        #a method to maximize reward and alot the weights based on that
        reward = -1*reward
        optimizer = tf.train.GradientDescentOptimizer(LearningRate).minimize(reward)
        init_m = tf.compat.v1.global_variables_initializer()
        with tf.Session as session:
            session.run(init_m)
            session.run(optimizer)
    def output_function(self, a = []):
        b = tf.nn.softmax(a, name='sigmoid')
        out = b*a
        return out
    def get_var_list(self):
        ls = tf.trainable_variables()
        iii = tf.global_variables_initializer()
        with tf.Session() as sessio:
            sessio.run(iii)
            l = sessio.run(ls)
        return l, ls
    def nn_run(self, joint_angles):
        m_dict = {}
        #function that directly runs the neural network and returns the prediction
        joint_angles = tf.compat.v1.convert_to_tensor(joint_angles, dtype=tf.float32)
        joint_angles = tf.compat.v1.reshape(joint_angles, shape=[24, 1])
        sessi = tf.InteractiveSession()
        with tf.compat.v1.variable_scope("weight_in_main", reuse=tf.compat.v1.AUTO_REUSE):
            weight_i_m = tf.compat.v1.get_variable("weight_input_main", dtype=tf.float32, shape=[self.neurons, 1], initializer=self.weight_initer)
            init_i_m = tf.compat.v1.global_variables_initializer()
            sessi.run(init_i_m)
        with tf.compat.v1.variable_scope("weight_hid_main", reuse=tf.compat.v1.AUTO_REUSE):   
            weights_h_m = tf.compat.v1.get_variable("weight_hidden_main", dtype=tf.float32, shape=[int(self.neurons/3), int(self.layers)], initializer=self.weight_initer1)
            init_h_m = tf.compat.v1.global_variables_initializer()
            sessi.run(init_h_m)
        with tf.compat.v1.variable_scope("weight_hid_cont_main", reuse=tf.compat.v1.AUTO_REUSE):
            weights_h_c_m = tf.compat.v1.get_variable("weight_hid_cont_main", dtype=tf.float32, shape=[int(self.neurons/3), 1], initializer=self.weight_initer2)
            init_h_c_m = tf.compat.v1.global_variables_initializer()
            sessi.run(init_h_c_m)
        with tf.compat.v1.variable_scope("weight_out_main", reuse=tf.compat.v1.AUTO_REUSE): 
            weights_o_m = tf.compat.v1.get_variable("weight_input_main", dtype=tf.float32, shape=[int(self.neurons), 1], initializer=self.weight_initer3)
            init_o_m = tf.compat.v1.global_variables_initializer()
            sessi.run(init_o_m)
        with tf.compat.v1.variable_scope("bias_in_main", reuse=tf.compat.v1.AUTO_REUSE): 
            bias_i_m = tf.compat.v1.get_variable("bias_input_main", dtype=tf.float32, shape=[self.neurons, 1], initializer=self.bias_initer)
            init_i_b_m = tf.compat.v1.global_variables_initializer()
            sessi.run(init_i_b_m)    
        with tf.compat.v1.variable_scope("bias_hid_main", reuse=tf.compat.v1.AUTO_REUSE): 
            bias_h_m = tf.compat.v1.get_variable("bias_hidden_main", dtype=tf.float32, shape=[int(self.neurons/3), 1], initializer=self.bias_initer1)
            init_h_b_m = tf.compat.v1.global_variables_initializer()
            sessi.run(init_h_b_m)
        with tf.compat.v1.variable_scope("bias_hid_cont_main", reuse=tf.compat.v1.AUTO_REUSE):
            bias_h_c_m = tf.compat.v1.get_variable("bias_hidden_cont_main", dtype=tf.float32, shape=[int(self.neurons/3), 1], initializer=self.bias_initer2)
            init_h_c_b_m = tf.compat.v1.global_variables_initializer()
            sessi.run(init_h_c_b_m)
        with tf.compat.v1.variable_scope("bias_out_main", reuse=tf.compat.v1.AUTO_REUSE): 
            bias_o_m = tf.compat.v1.get_variable("bias_out_main", dtype=tf.float32, shape=[int(self.neurons), 1], initializer=self.bias_initer3)
            init_o_b_m = tf.compat.v1.global_variables_initializer()
            sessi.run(init_o_b_m)
        uninitialized_variables_main = []
        print("printing the names of all variables")
        print(tf.all_variables())
        for var in tf.all_variables():
            try:
                sessi.run(var)
            except tf.errors.FailedPreconditionError:
                uninitialized_variables_main.append(var)
        
        init_m = tf.variables_initializer(uninitialized_variables_main)
        sessi.run(init_m)
        input_layer_activation = tf.add(tf.multiply(joint_angles, weight_i_m), bias_i_m)
        input_layer_output = tf.compat.v1.nn.leaky_relu(input_layer_activation, alpha=0.05)
        print("printing joint angles fr main network")
        print(tf.compat.v1.shape(input_layer_output))
        input_layer_output = tf.compat.v1.reshape(input_layer_output, shape=[8, 3]) 
        if(self.neuron_hidden_context != None):
            n_h_c = tf.compat.v1.convert_to_tensor(self.neuron_hidden_context, dtype=tf.float32)
            input_layer_out = tf.compat.v1.concat([input_layer_output, n_h_c], 1)
            hidden_layer_activation_multiply = tf.compat.v1.multiply(input_layer_out, weights_h_m)
            hidden_layer_activation_input = tf.compat.v1.add(hidden_layer_activation_multiply[:,0], hidden_layer_activation_multiply[:, 1])
            hidden_layer_activation_input = tf.compat.v1.add(hidden_layer_activation_input, hidden_layer_activation_multiply[:, 2])
            hidden_layer_activation_input = tf.compat.v1.add(hidden_layer_activation_input, hidden_layer_activation_multiply[:,3])
            hidden_layer_activation_input = tf.compat.v1.reshape(hidden_layer_activation_input, [8, 1])
            hidden_layer_activation = tf.compat.v1.add(hidden_layer_activation_input, bias_h_m)
        elif(self.neuron_hidden_context == None):
            hidden_layer_activation_multiply = tf.compat.v1.multiply(input_layer_output, weights_h_m[:,0:3])
            hidden_layer_activation_input = tf.compat.v1.add(hidden_layer_activation_multiply[:,0], hidden_layer_activation_multiply[:, 1])
            hidden_layer_activation_input = tf.compat.v1.add(hidden_layer_activation_input, hidden_layer_activation_multiply[:, 2])
            hidden_layer_activation_input = tf.compat.v1.reshape(hidden_layer_activation_input, [8, 1])
            hidden_layer_activation = tf.compat.v1.add(hidden_layer_activation_input, bias_h_m)
        hidden_layer_output = tf.compat.v1.nn.leaky_relu(hidden_layer_activation, alpha=0.05)
        print("printing hidden_layer_out")
        print(sessi.run(hidden_layer_output))
        neurons_hidden_context = tf.compat.v1.add(tf.compat.v1.multiply(hidden_layer_output, weights_h_c_m), bias_h_c_m)
        print("printing hidden_layer_out")
        print(sessi.run(neurons_hidden_context))
        self.neuron_hidden_context = tf.compat.v1.nn.leaky_relu(neurons_hidden_context, alpha=0.05)
        output_layer_mask = tf.compat.v1.constant([0.25, 0.25, 0.5])
        output_layer_mask = tf.compat.v1.tile(output_layer_mask, [8])
        output_layer_mask = tf.compat.v1.reshape(output_layer_mask, [8, 3])
        output_layer_mask = tf.compat.v1.cast(output_layer_mask, dtype=tf.float32)
        output_layer_input = tf.compat.v1.multiply(hidden_layer_output, output_layer_mask)
        output_layer_input = tf.compat.v1.reshape(output_layer_input, [24, 1])
        output_layer_activation = tf.compat.v1.add(tf.compat.v1.multiply(output_layer_input, weights_o_m), bias_o_m)
        output_layerout = tf.compat.v1.nn.leaky_relu(output_layer_activation, alpha=0.05)
        variables_list_m, variables_m = self.get_var_list()
        for var, val in zip(variables_m, variables_list_m):
            #print("var: {}, value: {}".format(var.name, val))
            m_dict[var.name] = val
        reward = self.reward_method(output_layerout)
        learningrate = 0.01
        reward = -1*reward
        optimizer = tf.train.GradientDescentOptimizer(learningrate).minimize(reward)
        init_m = tf.compat.v1.global_variables_initializer()
        sessi.run(init_m)
        sessi.run(optimizer)
        out = sessi.run(output_layerout)
        print("printing the shape of input of output layer") 
        print(out)
        out = np.nan_to_num(out, posinf=1.35)
        return out, m_dict
    def nn_learn(self,  rew):
        Learningrate = 0.1
        self.NN_learningReward(Learningrate, rew)


    

